unit Global;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Use_Geom;   

const
  Max_Balls = 100;
  Max_WayPoints = 200;
  Max_Parts = 1000;
  Max_Bonus = 5;

type
  TBall = record
   Point:TVect;
   Vect:TVect;
   Len:single;
   ang:single;
   real:boolean;
   Death:byte;
   tip:byte;{color}
   wp_tip:byte;
  end;

  TFlyBall = record
   Point:TVect;
   Vect:TVect;
   Len:single;
   ang:single;
   real:boolean;
   tip:byte;{color}
  end;

  TWayPoint = record
   Point:TVect;
   Next:integer;
   tip:byte;
   Len:single;
   Ang:Single;
  end;

  THero = record
   Point:TVect;
   Ang:Single;
   Power:single;
   lifes:byte;
   Color:byte;
  end;

  TPart = record
   Point:TVect;
   Vect:TVect;
   tip:byte;
   life:integer;
  end;

  TBonus = record
   Point:TVect;
   Life:integer;
   tip:byte;  {0-stop 1-slow 2-fastballs 3- back}
  end;

  TLoadSave = record
   WP:array [0..Max_WayPoints] of TWayPoint;
   Gen_Points:array [0..3] of TVect;
  end;

const
  wp_none = 0;
  wp_usual = 1;
  wp_begin = 2;
  wp_end = 3;
  wp_hide = 4;

  Death_anim = 30;

  mm_none = 0;
  mm_usual = 1;
  mm_slow = 2;
  mm_back = 3;
  mm_hyper = 4;

var
  hWnd: THandle;      {  }
  Msg: TMsg;         
  WCE: TWndClassEx;
  PW,PH:integer;
  glhRC:HGLRC;
  glhDC:HDC;
  Mode:boolean = false;
  {timer}
  tactH: Integer;
  {keys}
  key: array [0..255] of boolean; {}
  {Screen props}
  Mash:single = 1;{}
  KX,KY:single;{  }
  FOOL:boolean;{ }
  {mouse coords}
  Mx,My:integer;   {}
  MW:integer;
  DX,DY:single;    {   }
  mbl,mbr,mbm:boolean;       {     }
  {game}
  MaxL:Single;
  Game_Mode:integer;
  Is_Started:boolean = false;
  Balls_Move_Mode:byte;
  Edit_Mode:boolean;
  Edit_wp:integer = -1;

  pl_bonus:integer = -1;
  bonus_time:integer;

  BallRad:single = 0.4;
  WP:array [0..Max_WayPoints] of TWayPoint;
  Ball:array [0..Max_Balls] of TBall;
  Part:Array[0..Max_Parts] of TPart;
  Bonus:array[0..Max_Bonus] of TBonus;
  Gen_Points:array [0..3] of TVect;{Point of Bonus generation}
  flyBall:TFlyBall;
  Hero:THero;
  Move_Mode:byte;
  {}
  Waves:byte;
  Level:byte;
  Points:integer =0;

  ColorBalls:array [1..6] of byte;
  Max_Colors:byte=6;
  Ball_col:byte;

  M_alpha:integer;
  {Textures}
  Fon:cardinal;          {  }
  Tex:array [0..8] of cardinal;
  Bon:array [0..3] of cardinal;

procedure add_Ball(X,Y:single;Len:single;tip:byte);
procedure add_FlyBall(X,Y,VX,VY:single;tip:byte);
procedure Add_Part(X,Y,VX,VY:single;tip:byte;Life:integer);
procedure Add_Bonus(X,Y:single;tip,Life:integer);
procedure Save_Level(name:string);
procedure Load_Level(name:string);
procedure Gen_Balls(tip:byte);

implementation


procedure Save_Level(name:string);
Var i:integer;L:TLoadSave;F:File of TLoadSave;
begin
 for i:=0 to Max_WayPoints do
  L.WP[i]:=WP[i];
 for i:=0 to 3 do
  L.Gen_Points[i]:=Gen_Points[i];
 AssignFile(F,name);
 rewrite(F);
 write(F,L);
 CloseFile(f);
end;

procedure Load_Level(name:string);
Var i:integer;L:TLoadSave;F:File of TLoadSave;
begin
 AssignFile(F,name);
 reset(F);
 read(F,L);
 CloseFile(f);
 for i:=0 to Max_WayPoints do
  WP[i]:=L.WP[i];
 for i:=0 to 3 do
  Gen_Points[i]:=L.Gen_Points[i];
end;

procedure Gen_Balls(tip:byte);
Var i,s,t:byte;
Begin
 Case tip of
  0:for i:=0 to Max_Balls do
    begin
     Move_Mode:=mm_none;
     Ball[i].Point:=Vector(20,20);
     Ball[i].real:=true;
     Ball[i].Death:=i+Max_Balls;
     Ball[i].tip:=12;
     Ball[i].Len:=i/2;
    end;
  1:begin
     Move_Mode:=mm_usual;
     for i:=0 to 30 do
      begin
       s:=Random(Max_Colors-1)+1;
       if s=t then s:=Random(Max_Colors-1)+1;
       add_Ball(20,20,0.2+i*0.1,S);
       t:=s;
      end;
     Ball[0].tip:=0;
     Ball[0].Len:=0;
    end;
  2:for i:=0 to Max_Balls do
    begin
     Move_Mode:=mm_usual;
     Ball[i].real:=false;
    end;
  3:begin
     for i:=0 to 40 do
      begin
       Move_Mode:=mm_usual;
       add_Ball(20,20,0.2+i*0.1,Random(5)+1);
      end;
     Ball[0].tip:=0;
     Ball[0].Len:=0;
    end;
 end;
end;

{------------------}

procedure add_Ball(X,Y:single;Len:single;tip:byte);
Var i:integer;
begin
 for i:=0 to Max_Balls do
 if not Ball[i].real then
  begin
   Ball[i].Point:=Vector(X,Y);
   Ball[i].real:=true;
   Ball[i].Death:=Death_anim;
   Ball[i].tip:=tip;
   Ball[i].Len:=Len;
   break;
  end;
end;

procedure add_FlyBall(X,Y,VX,VY:single;tip:byte);
Var i:integer;
begin
 FlyBall.Point:=Vector(X,Y);
 FlyBall.Vect:=Vector(VX,VY);
 FlyBall.ang:=Get_A(FlyBall.Vect);
 FlyBall.real:=true;
 FlyBall.tip:=tip;
end;

procedure Add_Part(X,Y,VX,VY:single;tip:byte;Life:integer);
Var i:integer;
begin
 For i:=0 to Max_Parts do
  if Part[i].life=0 then
   begin
    Part[i].Point:=Vector(X,Y);
    Part[i].Vect:=Vector(VX,VY);
    Part[i].tip:=tip;
    Part[i].life:=life;
    break;
   end;
end;

procedure Add_Bonus(X,Y:single;tip,Life:integer);
Var i:integer;
begin
 For i:=0 to Max_Bonus do
  if Bonus[i].life=0 then
   begin
    Bonus[i].Point:=Vector(X,Y);
    Bonus[i].tip:=tip;
    Bonus[i].life:=life;
    break;
   end;
end;

end.
