unit Main;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Global,
  Use_OpenGL,
  Use_PNG,
  Use_Geom,
  Use_Menu;

procedure TactTimer;
procedure Create_prog;
procedure Kill_Prog;

implementation

procedure cout_way;
Var i,j:integer;
max:single;
begin
max:=0;
 for i:=0 to Max_WayPoints-1 do
 // if WP[i].tip>wp_none then
  begin
   if WP[i].tip=wp_begin then max:=0;
   WP[i].Len:=max;
   max:=max+Get_S(WP[i].Point,WP[i+1].Point);
  end;
 MaxL:=Max;
 for i:=0 to Max_WayPoints-1 do
 // if WP[i].tip>wp_none then
  begin
   WP[i].ang:=Get_A(WP[i].Point,WP[i+1].Point);
  end;
end;

procedure Put_Part(Part:TPart);
Var Size:single;
begin
 glColor4f(5,5,5,Part.life/4);
 Size:=0.2;
 case Part.tip of
  12:begin
     size:=0.07+Part.life*0.01;
     glBindTexture(GL_Texture_2D,Tex[8]); {energy}
    end;
  1:glBindTexture(GL_Texture_2D,Tex[3]); {List}
  2:begin
     size:=0.12;
     glBindTexture(GL_Texture_2D,Tex[4]); {water}
    end;
  3:begin
     size:=0.08+Part.life*0.02;
     glBindTexture(GL_Texture_2D,Tex[5]); {fire}
    end;
  4:begin
     size:=0.1+Part.life*0.02;
     glBindTexture(GL_Texture_2D,Tex[6]); {Chaos}
    end;
  5:begin
     size:=0.15+Part.life*0.01;
     glBindTexture(GL_Texture_2D,Tex[7]); {ice}
    end;
  10:begin
     size:=0.1+Part.life*0.03;
     glColor4f(0,0,0,0.1);
     glBindTexture(GL_Texture_2D,Tex[5]); {dim}
    end;
  11:begin
     size:=0.12;
     glBindTexture(GL_Texture_2D,Tex[4]); {water}
    end;
 end;
 put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,1,Size);
end;

function rand_tip():byte;
Var i,f:byte;
begin
 i:=0;
  repeat
   f:=random(Max_Colors-1)+1;
   i:=i+1;
  until (ColorBalls[f]>0) or (i>10);
 rand_tip:=f;
end;

procedure put_Bonus(Bonus:TBonus);
begin
 glColor4f(5,5,5,1);
 glBindTexture(GL_Texture_2D,Bon[Bonus.tip]);{water}
 put_Sprite(Bonus.Point.X-KX,Bonus.Point.Y-KY,1,0.6);
end;

procedure put_Ball(Ball:TBall);
begin
// choose_color(Ball.tip);
 glColor4f(5,5,5,1);
 Case Ball.tip of
  0:begin
     glBindTexture(GL_Texture_2D,Tex[8]);{dvig}
     put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,Random(360),1,BallRad+(+Death_anim-Ball.Death)/200);
     glBindTexture(GL_Texture_2D,Tex[0]);{dvig}
     put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,1,BallRad+(+Death_anim-Ball.Death)/200);
    end;
  1:glBindTexture(GL_Texture_2D,Tex[3]);{List}
  2:glBindTexture(GL_Texture_2D,Tex[4]);{water}
  3:glBindTexture(GL_Texture_2D,Tex[5]);{fire}
  4:begin
     glBindTexture(GL_Texture_2D,Tex[6]); {Chaos}
     put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,Random(360),1,BallRad+(+Death_anim-Ball.Death)/200);
    end;
  5:glBindTexture(GL_Texture_2D,Tex[7]);{ice}
  12:begin
     glBindTexture(GL_Texture_2D,Tex[8]); {waypoints}
     put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,Random(360),1,BallRad-abs(Ball.Death-Max_Balls)/100);
    end;
 end;
 if (Ball.wp_tip<>wp_hide) then
  if (Ball.tip>0) and (Ball.tip<>12) and (Ball.tip<>4) then
  put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,1,BallRad+(+Death_anim-Ball.Death)/200);
end;

procedure put_Cursor(X,Y:Single);
begin
 glColor4f(5,5,5,1);
 Case Hero.Color of
  1:glBindTexture(GL_Texture_2D,Tex[3]);{List}
  2:glBindTexture(GL_Texture_2D,Tex[4]);{water}
  3:glBindTexture(GL_Texture_2D,Tex[5]);{fire}
  4:glBindTexture(GL_Texture_2D,Tex[6]);{Chaos}
  5:glBindTexture(GL_Texture_2D,Tex[7]);{ice}
 end;
  put_Sprite(X,Y,1,0.2);
end;

procedure put_Hero(Hero:THero);
begin
 glColor4f(5,5,5,0.4);
 glBindTexture(GL_Texture_2D,Tex[0]);{dvig}
 put_Sprite(Hero.Point.X-KX,Hero.Point.Y-KY,1,0.5);
 glColor4f(5,5,5,1);
 Case Hero.Color of
  1:glBindTexture(GL_Texture_2D,Tex[3]);{List}
  2:glBindTexture(GL_Texture_2D,Tex[4]);{water}
  3:glBindTexture(GL_Texture_2D,Tex[5]);{ fire}
  4:glBindTexture(GL_Texture_2D,Tex[6]);{Chaos}
  5:glBindTexture(GL_Texture_2D,Tex[7]);{ice}
 end;
  put_Sprite(Hero.Point.X-KX,Hero.Point.Y-KY,Hero.Ang,1,0.4);
end;

procedure put_FlyBall(Ball:TFlyBall);
begin
 glColor4f(5,5,5,1);
 Case Ball.tip of
  1:glBindTexture(GL_Texture_2D,Tex[3]);{List}
  2:glBindTexture(GL_Texture_2D,Tex[4]);{water}
  3:glBindTexture(GL_Texture_2D,Tex[5]);{fire}
  4:glBindTexture(GL_Texture_2D,Tex[6]);{Chaos}
  5:glBindTexture(GL_Texture_2D,Tex[7]);{ice}
 end;
  put_Sprite(Ball.Point.X-KX,Ball.Point.Y-KY,1,BallRad);
end;

procedure Check_Keys;       { }
begin
 DX:=((+MX-PW/2)*0.0129/mash)+kx;
 DY:=((-MY+PH/2)*0.0129/mash)+ky; {   }
 if mbl and (Game_Mode=1) and not Edit_Mode then
  begin
   if FlyBall.real=false then
    begin
     add_Flyball(Hero.Point.X,Hero.Point.Y,
            Get_X_V(Hero.ang,Hero.Power),Get_Y_V(Hero.ang,Hero.Power),
            Hero.Color);
     Hero.Color:=rand_tip();
    end;
  end;
  if mbl and Edit_Mode then  {add point}
  begin
   if edit_wp>0 then
    begin
     WP[edit_wp].tip:=wp_usual;
     WP[edit_wp].Next:=edit_wp+1;
    end;
   edit_wp:=edit_wp+1;
   WP[edit_wp].Point.X:=DX;
   WP[edit_wp].Point.Y:=DY;
   WP[edit_wp].Next:=edit_wp;
   WP[edit_wp].tip:=wp_end;
   WP[0].tip:=wp_begin;
   mbl:=false;
   cout_way;
  end;
 if key[46] then
 begin
  WP[Edit_wp].tip:=wp_end;
  WP[Edit_wp].Next:=Edit_wp;
  if Edit_wp>0 then
   Edit_WP:=Edit_Wp-1;
  WP[Edit_wp].tip:=wp_none;
  Key[46]:=false;
  cout_way;
 end;
 if key[112] then {f1 save}
 begin
  Save_Level('test_lev.txt');
 end;
 if key[113] then {f2 load}
 begin
  Load_Level('test_lev.txt');
 end;
 if key[192] then {` -  edit mode}
 begin
  edit_mode:=not edit_mode;
  key[192]:=false;
 end;
 if key[49] then   {1}
 begin
  key[49]:=false; gen_Balls(0);
 end;
 if key[50] then   {2}
 begin
  key[50]:=false; gen_Balls(1);
 end;
 if key[51] then   {3}
 begin
  key[51]:=false; gen_Balls(2);
 end;
 {81,87,69,82 - q w e r - 4 points of generaion bonus}
 if key[81] and edit_mode then Gen_Points[0]:=Vector(DX,DY);
 if key[87] and edit_mode then Gen_Points[1]:=Vector(DX,DY);
 if key[69] and edit_mode then Gen_Points[2]:=Vector(DX,DY);
 if key[82] and edit_mode then Gen_Points[3]:=Vector(DX,DY);
 if key[32] then
  begin
   Gen_Balls(0);
  end;
 if key[27] then
  begin
   key[27]:=false;
   if Is_Started then Choosen_Group:=4;
   if Game_Mode=1 then Game_Mode:=0
   else
    if Is_Started then Game_Mode:=1; {Esc }
  end;
end;

procedure use_Bonus;
begin
 if Bonus_Time>0 then Bonus_Time:=Bonus_Time-1;
 if Bonus_time>0 then
 case pl_Bonus of
 0:Move_Mode:=mm_none;
 1:Move_Mode:=mm_slow;
 2:Hero.Power:=0.3;
 3:begin
    Move_Mode:=mm_back;
    if Bonus_time>100 then Bonus_time:=100;
   end;
 end else
 case pl_Bonus of
 0:begin pl_bonus:=-1;Move_Mode:=mm_usual;end;
 1:begin pl_bonus:=-1;Move_Mode:=mm_usual;end;
 2:begin pl_bonus:=-1;Hero.Power:=0.2;Move_Mode:=mm_usual;end;
 3:begin pl_bonus:=-1;Move_Mode:=mm_usual;end;
 end;
end;

procedure move_Parts;
Var i:integer;
begin
 {Particles}
 For i:=0 to Max_Parts do
 if Part[i].life>0 then
 begin
  Part[i].life:=Part[i].Life-1;
  Case Part[i].tip of
   0,4:begin{energy}
      Part[i].Point:=plus(Part[i].Point,Part[i].Vect);
     end;{iskri - letyat v raznie storoni}
   1,2,5:begin
           Part[i].Point:=plus(Part[i].Point,Part[i].Vect);
           Part[i].Vect:=plus(Part[i].Vect,Vector(0,-0.005));
          end;{chastici -opuskautsya vniz }
   3:begin
           if Part[i].Life=0 then Part[i].tip:=10;
           if Part[i].Life=0 then Part[i].life:=4;
           Part[i].Point:=plus(Part[i].Point,Part[i].Vect);
           Part[i].Vect:=plus(Part[i].Vect,Vector(0,+0.005));
          end;{chastici -podnimautsa vverh }{fire}
   10:begin
           Part[i].Point:=plus(Part[i].Point,Part[i].Vect);
           Part[i].Vect:=plus(Part[i].Vect,Vector(0,+0.005));
          end;{chastici -podnimautsa vverh } {dim}
   11:;
  end;
 end;
end;

procedure Move_Balls;
Var
 i,j,z,m:integer;
 L,S:single;
 Check:boolean;
 F:array [0..Max_Balls] of integer;
begin
 {test}
 if random(1000)=0 then
 begin
  i:=random(4);
  add_bonus(Gen_Points[i].X,Gen_Points[i].Y,Random(4),300);
 end;
 {bonuses}
 for i:=0 to Max_Bonus do
 if Bonus[i].Life>0 then
  begin
   Bonus[i].Life:=Bonus[i].Life-1;
   if (Point_in_Rect(FlyBall.Point.X,FlyBall.Point.Y,
    Bonus[i].Point.X-0.6,Bonus[i].Point.Y-0.6,
    Bonus[i].Point.X+0.6,Bonus[i].Point.Y+0.6)) and
    (FlyBall.real) then
    begin
     pl_Bonus:=Bonus[i].tip;
     Bonus[i].Life:=15;
     Bonus_time:=300;
     FlyBall.real:=false;
     Points:=Points+10;
   end;
  end;
 {ball effects}
 For i:=0 to Max_Balls do
  if Ball[i].real then
   case Ball[i].tip of
    3:add_Part(Ball[i].Point.X,Ball[i].Point.Y,(Random(10)-5)/500,(Random(10)-5)/500,3,15);
    2:add_Part(Ball[i].Point.X+(Random(10)-5)/50,Ball[i].Point.Y+(Random(10)-5)/50,0,0,11,10);
  end;
 {balls}
 case Move_Mode of  {ball move mode}
  mm_none:begin L:=0;S:=0;end;{none moving}
  mm_usual:begin L:=0.01;S:=-0.005;end;{usual}
  mm_slow:begin L:=0.008;S:=-0.005;end;
  mm_back:begin L:=-0.007;S:=-0.007;end;
  mm_hyper:begin L:=0.15;S:=0.01;end;
 end;
 Ball[0].Len:=Ball[0].Len+L; {last Ball is moving}
 For i:=0 to Max_Balls do
  if Ball[i].real then
   begin
    if (Ball[i].Death<Death_anim) or (Ball[i].tip=12) then   {death animation}
     Ball[i].Death:=Ball[i].Death-1;
    if Ball[i].Death<=0 then
     begin
      Ball[i].real:=false;            {death}
      Ball[i].Len:=-1;
      if (Ball[i].tip<>12) then
       Points:=Points+1;
      for m:=0 to 10 do
       add_Part(Ball[i].Point.X,Ball[i].Point.Y,(Random(10)-5)/100,(Random(10)-5)/100,Ball[i].tip,12);
     end;
    Ball[i].Len:=Ball[i].Len+S; {all Balls is moving backvard}
   end;

 {FlyBall Moving}
 if FlyBall.real then
  begin
   FlyBall.Point:=plus(FlyBall.Point,FlyBall.Vect);
   add_Part(FlyBall.Point.X,FlyBall.Point.Y,(Random(10)-5)/100,(Random(10)-5)/100,FlyBall.tip,20);
   {collisions between balls and flyBall}
   j:=-1;
   S:=10;
   for i:=0 to Max_Balls do  {Search of nearest collision ball}
    if Ball[i].real then
     begin
      L:=Get_S(Ball[i].Point,FlyBall.Point);
      if (L<=BallRad) and (Ball[i].tip>0) and (Ball[i].wp_tip<>wp_hide) then
      begin
       if S>L then
        begin
         S:=L;
         j:=i;
        end;
      end;
     end;
   if j>=0 then {Collision!}
   begin       {flyBall  => ball}
    S:=Get_A(Ball[j].Point,FlyBall.Point);
    if (abs(Ball[j].ang-S)<90) then {ball insert forward of nearest}
     begin
      add_Ball(0,0,Ball[j].Len+BallRad/5,FlyBall.tip);
      for m:=0 to 5 do
       add_Part(FlyBall.Point.X,FlyBall.Point.Y,(Random(10)-5)/100,(Random(10)-5)/100,FlyBall.tip,15);
     end else {ball insert backward nearest}
     begin
      add_Ball(0,0,Ball[j].Len-BallRad/5,FlyBall.tip);
      for m:=0 to 5 do
       add_Part(FlyBall.Point.X,FlyBall.Point.Y,(Random(10)-5)/100,(Random(10)-5)/100,FlyBall.tip,15);
     end;
    FlyBall.real:=false;
   end;
   {if FlyBall is out of scene}
   If not Point_in_Rect(FlyBall.Point,Vector(-7,-5),Vector(7,5)) then
    begin
     FlyBall.real:=false;
    end;
  end;
 {collisions between balls}
 for i:=0 to Max_Balls do
 if Ball[i].real then
  for j:=0 to Max_Balls do
  if Ball[j].real and (i<>j) then
   begin
    S:=abs(Ball[i].Len-Ball[j].Len);
    if (abs(Ball[j].Len-Ball[i].Len)<BallRad) then
     begin
      Ball[i].Len:=Ball[i].Len+((BallRad)-S)*0.55;
      Ball[j].Len:=Ball[j].Len-((BallRad)-S)*0.2;
     end
   end;
  {moving}
 for i:=0 to Max_WayPoints do
  if WP[i].tip>wp_none then
   begin
    for j:=0 to Max_Balls do
     if Ball[j].real then
      if (Ball[j].Len>=WP[i].Len) and (Ball[j].Len<WP[i+1].Len) then
       begin
        Ball[j].wp_tip:=WP[WP[i].Next].tip;
        Ball[j].Point:=plus(WP[i].Point,
         multi(
          minus(WP[i+1].Point,WP[i].Point) ,(Ball[j].Len-WP[i].Len)/(WP[i+1].Len-WP[i].Len) ) );
        Ball[j].ang:=WP[i+1].ang;
       end;
   end;
 {Balls kill}
 L:=0;
 z:=0;
 M:=1;
 For i:=0 to Max_Balls do
  F[i]:=0;
 F[0]:=0;
 for j:=0 to Max_Balls do
  begin
  Check:=false;
  L:=10000;
  for i:=0 to Max_Balls do
   if Ball[i].real and (F[Z]<>i) then
   if (Ball[i].Len<L) and (Ball[i].Len>Ball[F[Z]].Len) then
    begin
     L:=Ball[i].Len;
     m:=i;
     Check:=true;
    end;
  if Check then
   begin
    Z:=Z+1;
    F[Z]:=M;
   end else break;
  end;
 {j - current Color z - how mutch balls of current color}
 j:=1;
 m:=0;
 for i:=0 to Z do
  begin
   if Ball[F[i]].tip=j then {sovpadenie cveta - +shar}
   begin
    m:=m+1;
   end else
   begin                 {nesovpadenie}
    if (m>=2) then       {esli tri ili bolee - boom}
     for j:=1 to m+1 do
      begin
       if (Ball[F[i-j]].Death=Death_anim) then
        Ball[F[i-j]].Death:=Death_anim-1;
      end;
    j:=Ball[F[i]].tip;      {zbrasivaem cvet}
    m:=0;                {zbrasivaem kol-vo sharicov}
   end;
  end;
  if (m>=2) then       {esli tri ili bolee - boom}
   for j:=1 to m+1 do
    begin
     if Ball[F[i-j]].Death=Death_anim then
      Ball[F[i-j]].Death:=Death_anim-1;
    end;
 {podschet sharov po cvetam}
 For i:=1 to 6 do
  ColorBalls[i]:=0;
 Ball_Col:=0;
 For i:=0 to Max_Balls do
  if (Ball[i].real) then
  if (Ball[i].tip>0)  then
   begin
    ColorBalls[Ball[i].tip]:=ColorBalls[Ball[i].tip]+1;
    Ball_Col:=Ball_Col+1;
    if (Ball[i].wp_tip = wp_end) then
     begin
      Ball[i].real:=false;
      if (Ball[i].tip<>12) then
      Move_Mode:=mm_hyper;
     end;
   end;
 if (Ball_Col=0) and not edit_mode then
  begin
   if (Move_Mode=mm_hyper) then
    begin            {gameover}
     Is_Started:=false;
     Game_Mode:=0; {view menu}
     Choosen_Group:=6;{view message GameOver}
    end else
    if Waves>1 then {next_Wave}
     begin
      Waves:=waves-1;
      Gen_Balls(2);
      Gen_Balls(1);
     end {end of waves - victory}
     else
    begin            {victory}
     Texts[EndMess].Text:='!   '+IntToStr(Points)+' !';
     Waves:=waves-1;
     Is_Started:=false;
     Gen_Balls(2);
     Game_Mode:=0; {view menu}
     Choosen_Group:=5;{view message GameOver}
     if Level=3 then
      begin
       Level:=4;
       Waves:=3;
       Load_Level('Levels/Dark_Lord1.lev');
       Gen_Balls(0);
       Choosen_Group:=4;
       Game_Mode:=1;
      end
    end

  end;
end;

procedure Render;    {}
Var
  i,j:integer;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
{render}
 if Waves>0 then M_alpha:=0 {dark monsters}
  else if M_alpha<50 then M_alpha:=M_alpha+1;
 glColor4f(M_alpha/10,M_alpha/10,M_alpha/10,5);
 glEnable(GL_Texture_2d);
 glBindTexture(GL_Texture_2D,Tex[2]);
 glbegin(GL_Quads);
  gltexcoord2f(0,0);  glvertex2f(-6.7,-5);    {}
  gltexcoord2f(6,0);  glvertex2f(+6.7,-5);
  gltexcoord2f(6,6);  glvertex2f(+6.7,+5);
  gltexcoord2f(0,6);  glvertex2f(-6.7,+5);
 glend;
 glColor4f(5,5,5,5);
 glBindTexture(GL_Texture_2D,Fon);
 glbegin(GL_Quads);
  gltexcoord2f(0,0);  glvertex2f(-6.7,-5);    {}
  gltexcoord2f(1,0);  glvertex2f(+6.7,-5);
  gltexcoord2f(1,1);  glvertex2f(+6.7,+5);
  gltexcoord2f(0,1);  glvertex2f(-6.7,+5);
 glend;
 glBindTexture(GL_Texture_2D,Tex[0]);
 {balls}
 for i:=0 to Max_Balls do
  if Ball[i].real then
  begin
   put_Ball(Ball[i]);
  end;
 for i:=0 to Max_Bonus do
  If Bonus[i].Life>0 then
   put_bonus(Bonus[i]);
 {particles}
 For i:=0 to Max_Parts do
  if (Part[i].life>0) then Put_Part(Part[i]);
 {flyBall}
 if FlyBall.real then
  put_FlyBall(FlyBall);
 {hero}
 Hero.Ang:=Get_A(Hero.Point,Vector(DX,DY));
 put_Hero(Hero);
 {cursor}
 put_Cursor(DX-KX,DY-KY);
 glDisable(GL_Texture_2d);
 glColor3f(Random(5),Random(5),Random(5));
 if Edit_mode then
 for i:=0 to Max_WayPoints do
  if WP[i].tip>0 then
  begin
   glBegin(GL_Lines);
   glVertex2f(WP[i].Point.X-KX,WP[i].Point.Y-KY);
   glVertex2f(WP[WP[i].Next].Point.X-KX,WP[WP[i].Next].Point.Y-KY);
   glend;
  end;
 glColor3f(5,5,5);
 {edit mode}
 if Edit_Mode then
  Put_Text('Edit_Mode',-6,-4);
 If Game_Mode=1 then
  Put_Text(': '+IntToStr(Points),4.4,4);
 {Menu}
 glDisable(GL_Blend);
 if Game_Mode=0 then
  put_Menu;
 glEnable(GL_Blend);
 {render}
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 if Game_Mode=0 then
  Check_Menu((DX-KX)*Mash,(DY-KY)*Mash,mbl or mbr);
 use_Bonus;
 if Game_Mode=1 then
  Move_Balls;
 if Game_Mode=-1 then Kill_Prog;
 Move_Parts;
 Render;        {}
end;

procedure Create_prog;{ }
Var
  i,j:integer;
begin
 ShowCursor(false);  { }
 glClearColor(5.0,5.0,5.0,5);
 enable_bind_tex;
 glShadeModel(GL_FLAT{GL_SMOOTH});
 Gen_Font(glhDC);
 glDisable(GL_Depth_Test);
 glEnable(GL_Blend);
 KX:=0;
 KY:=0;
 {hero}
 Hero.Point:=Vector(10,10);
 Hero.Power:=0.2;
 Hero.Color:=Random(Max_Colors-1)+1;
 {balls}
 Create_Menu;
 Gen_Balls(0);
 cout_way;
 Fon:=0;
 for i:=0 to 8 do
  Tex[i]:=i+1;
 for i:=0 to 3 do
  Bon[i]:=10+i;
 LoadPNGTexture('IMG/Dragon.png',Fon);
 LoadPNGTexture('IMG/dvig.png',Tex[0]);
 LoadPNGTexture('IMG/Stone.png',Tex[2]);
 LoadPNGTexture('IMG/List.png',Tex[3]);
 LoadPNGTexture('IMG/Water.png',Tex[4]);
 LoadPNGTexture('IMG/Fire.png',Tex[5]);
 LoadPNGTexture('IMG/Chaos.png',Tex[6]);
 LoadPNGTexture('IMG/ice.png',Tex[7]);
 LoadPNGTexture('IMG/energy.png',Tex[8]);
 LoadPNGTexture('IMG/bonus_stop.png',Bon[0]);
 LoadPNGTexture('IMG/bonus_slow.png',Bon[1]);
 LoadPNGTexture('IMG/bonus_speed.png',Bon[2]);
 LoadPNGTexture('IMG/bonus_back.png',Bon[3]);
 {test}
 Move_Mode:=mm_usual;
 Waves:=4;
end;

procedure Kill_Prog;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
 KillTimer(0,TactH);     { }
 PostQuitMessage (0);
 ShowCursor(True);        { }
end;

end.
