unit GRecords;

interface
uses
  Omega, LexUtils, Bonses, Materials;
type
  TRec = record
    N : String[40];
    P : Cardinal;
    T : word;
  end;

  TRecTable = record
    R : array[1..10] of TRec;
  end;

var
  RecTable: TRecTable;
  NRN : byte = 11;
  TX2, TX3, TX0 : word;
  LookPR : byte = 177;

Procedure ClearRec;
Procedure LoadTRec;
Procedure SaveTRec;
Procedure DrawRecs;
Procedure RecRazmet;
Function NewRec : boolean;

implementation
uses
  MainProc, Game_A;

Procedure RecRazmet;
begin

  TX0:=240;
  TX2:=TX0 + 40 ;
  TX3:=TX2 +round(Text_GetWidth(Font1, PChar('---------------------------------------'),  FontS));

end;

Procedure SaveTRec;
var
  F : file of TRecTable;
begin
  assignFile(F, 'records.lex');
  rewrite(F);
  write(F, RecTable);
  closefile(F);
end;

Procedure ClearRec;
var
  I : byte;
begin
  For I:=1 to 10 do
   begin
      RecTable.R[I].N:='';
      RecTable.R[I].P:=0;
      RecTable.R[I].T:=0;
   end;
end;

Procedure LoadTRec;
var
  F : file of TRecTable;
begin
  if LexUtils.FileEx('records.lex') then
    begin
      assignFile(F, 'records.lex');
      reset(F);
      read(F, RecTable);
      closefile(F);
    end
  else
 ClearRec;
end;

Function NewRec : boolean;
var
  I, B : byte;
begin
  result:=false;
  B:=0;
  for I:=10 downto 1 do
  if Points>=RecTable.R[I].P then
    begin
      if I<NRN then
        begin
          result:=true;
          NRN:=I;
        end;
      B:=I;
    end;

  if (B>0) and (B<11) then
    begin
      RecTable.R[B].N := PlName;
      RecTable.R[B].P := Points;
      RecTable.R[B].T := round(PAllTime);
    end;

end;

Procedure DrawRecs;
var
  I : byte;
  Y : single;
  S, S1, S2 : String;
begin
  Omega.SSprite_Draw(TBGMap2, 0, 0, 1024, 768);
  Omega.ASprite_Draw(Tsp, 0, 0, 90, 90, MMS);
  Omega.SSprite_Draw(TBigSv, 120, 30, 784, 754);
  Omega.Text_Draw(Font1, 495,  1.15*90, '', 1, 0, 240, 180);
  for I:=1 to 10 do
    begin
      Y:=1.45*90 + I*90*0.45 ;
      S:=RecTable.R[I].N;
      Omega.Text_Draw(Font1, TX0, Y, PChar(U_Inttostr(I)+'.'), FontS, 0, 255, 200);
      Omega.Text_Draw(Font1, TX2, Y, PChar(S), FontS, 0, 255, 200);
      Omega.Text_Draw(Font1, TX3, Y, PChar(U_IntToSTr(RecTable.R[I].P)), FontS, 0, 255, 200);
    end;
end;


end.
