unit Game_A;

interface
uses
  Omega, PAP_map, PAP_materials, materials;

type
  TIsoCord = record
    X, Y : byte;
  end;
  Tpap = record
    C : byte;
    KX, KY,
    A2, wA,
    oX, oY : byte;

    X, Y, SX, SY, S, A : single;
    E : boolean;
  end;

  THomeCord = record
    X, Y : byte;
    Paps : array of Tpap;
    MofGO : byte;
  end;

  TGunCord = record
    X, Y : byte;
    C, T : byte;
  end;

  TpTile = record
    H, Z : byte;
    E : boolean;
  end;

procedure GameProc;
procedure GameDraw;
procedure CreatePaps(X : integer);

var
  points : integer;
  animatTile : array[1..18, 1..49] of integer;
  pTile : array[1..18, 1..49] of TpTile;
  Gun1Cord, Gun2Cord : array of TGunCord;
  AltCord : array of TIsoCord;
  HomeCord : array of THomeCord;

  MofPaps : byte = 10;

implementation
uses
  MainProc;

procedure CreatePaps(X : integer);
var
  I, R : integer;
begin
  SetLength(HomeCord[X].Paps, MofPaps);
  with HomeCord[X] do
  for I:=0 to MofPaps-1 do
    begin
      R:=random(7)+1;
      if (I>1) and (R=Paps[I-1].C)
      and (R=Paps[I-2].C) then
        begin
          if Paps[I-1].C>4 then
          R:=Paps[I-1].C-1
          else
          R:=Paps[I-1].C+1;
        end;
      Paps[I].E:=false;
      Paps[I].C:=R;
      Paps[I].A:=0;
    end;
end;

function whatroll(x2, x1, y2, y1 :real) : integer;
  function asmroll(x1, y1 :real) : real;
  asm
    FLD Y1
    FLD X1
    FPATAN
    FWAIT
  end;
begin
  result:=round(asmroll(x1-x2,y1-y2)*57.32);
end;

function AnimationRoll(iX, iY : integer): byte;
var
  X : integer;
begin
  X:=whatroll(cTile[iX, iY].X+64, Omega.Mouse_X, cTile[iX, iY].Y-32, Omega.Mouse_Y);
  X:=(X div 10);
  case X of
  -18 : result:= 5;
  -17 : result:= 6;
  -16 : result:= 7;
  -15 : result:= 8;
  -14 : result:= 9;
  -13 : result:= 10;
  -12 : result:= 10;
  -11 : result:= 11;
  -10 : result:= 12;
   -9 : result:= 13;
   -8 : result:= 14;
   -7 : result:= 15;
   -6 : result:= 16;
   -5 : result:= 17;
   -4 : result:= 18;
   -3 : result:= 18;
   -2 : result:= 19;
   -1 : result:= 21;
    0 : result:= 21;
    1 : result:= 21;
    2 : result:= 23;
    3 : result:= 24;
    4 : result:= 25;
    5 : result:= 25;
    6 : result:= 26;
    7 : result:= 27;
    8 : result:= 28;
    9 : result:= 29;
   10 : result:= 30;
   11 : result:= 31;
   12 : result:= 32;
   13 : result:= 1;
   14 : result:= 1;
   15 : result:= 2;
   16 : result:= 3;
   17 : result:= 4;
   18 : result:= 5;
   end;
end;

procedure Orient(H, I : byte);
function nC2(X1 : byte) : boolean;
begin
  if X1 mod 2 = 0 then
  result:=false else result:=true;
end;
function C2(X1 : byte) : boolean;
begin
  if X1 mod 2 = 0 then
  result:=true else result:=false;
end;

begin
   with HomeCord[H].Paps[I] do
    begin
      oX:=KX;
      oy:=KY;
      if  (map.iTile[oX, oY].Way>0)
      and (map.iTile[oX, oY].Way<9) then
      wA:=map.iTile[oX, oY].Way-1;

      case map.iTile[oX, oY].Way of
        1 : begin                              inc(KY, 2);  sX:=0;  sY:= 2; end;
        2 : begin if nc2(KY) then inc(KX, -1); inc(KY, 1);  sX:=-2; sY:= 1; end;
        3 : begin                              dec(KX, 1);  sX:=-4; sY:= 0;
                  end;
        4 : begin if nc2(KY) then inc(KX, -1); dec(KY, 1);  sX:=-2; sY:=-1;
                  end;
        5 : begin                              dec(KY, 2);  sX:= 0; sY:=-2;
                  end;
        6 : begin if C2(KY) then inc(KX,  1);  dec(KY, 1);  sX:= 2; sY:=-1;
                  end;
        7 : begin                              inc(KX, 1);  sX:= 4; sY:= 0; end;
        8 : begin if C2(KY) then inc(KX, 1);   inc(KY, 1);  sX:= 2; sY:= 1; end;
      end;
    end;
end;

procedure PapGo(H, I : byte);
begin
  with HomeCord[H].Paps[I] do
    begin
      if  (round(X)=cTile[KX, KY].X)
      and (round(Y)=cTile[KX, KY].Y) then
        begin
          pTile[oX, oY].E:=false;
          Orient(H, I);
          pTile[oX, oY].E:=true;
          pTile[oX, oY].H:=H;
          pTile[oX, oY].Z:=I;
        end
      else
        begin
          if wA<>A then
            begin
              if (A<2)
              and (wA>5)
              then
              A:=8
              else
              if  A>wA
              then
              A:=A-0.1
              else
              A:=A+0.1
            end;
          X:=X+sX*S;
          Y:=Y+sY*S;
          if (A2>0) and (A2<32) then
          inc(A2) else A2:=1;

        end;
    end;
end;

procedure GameProc;
var
  iX, iY, aX, aY : integer;
begin
  for iX:=0 to length(Gun1Cord)-1 do
  with Gun1Cord[iX] do
  animatTile[X, Y]:=AnimationRoll(X, Y);

  for iX:=0 to length(HomeCord)-1 do
  with HomeCord[iX] do
  if (animatTile[X, Y]>=20) and (animatTile[X, Y]<=80) then inc(animatTile[X, Y])
  else animatTile[X, Y]:=20;

  for iX:=0 to length(AltCord)-1 do
  with AltCord[iX] do
  if (animatTile[X, Y]>=20) and (animatTile[X, Y]<=80) then inc(animatTile[X, Y])
  else animatTile[X, Y]:=20;

  for iX:=0 to length(HomeCord)-1 do
    begin
      with HomeCord[iX].Paps[HomeCord[iX].MofGO] do
      if  (HomeCord[iX].MofGO<MofPaps)
      and (not pTile[HomeCord[iX].X, HomeCord[iX].Y].E)
      then
        begin
          inc(HomeCord[iX].MofGO);
          S:=0.2;
          X :=cTile[HomeCord[iX].X, HomeCord[iX].Y].X;
          Y :=cTile[HomeCord[iX].X, HomeCord[iX].Y].Y;
          kX:=HomeCord[iX].X;
          kY:=HomeCord[iX].Y;
          Orient(iX, HomeCord[iX].MofGO);
          E:=true;
          pTile[HomeCord[iX].X, HomeCord[iX].Y].E:=true;
        end;
      for iY:=0 to length(HomeCord[iX].Paps)-1 do
      if HomeCord[iX].Paps[iY].E then
      PapGo(iX, iY );
    end;

end;

procedure GameDraw;
begin
  Omega.SSprite_Draw(TBGMap3, 0, 0, 1024, 768);

  PAP_map.Draw_Tile;


  //   
  Omega.ASprite_Draw(Tsp, 0, 0, 90, 90, MMS);
end;

end.
