unit PAP_map;

interface
uses Omega, LexUtils, PAP_materials;

type
 // :
  TiTile = record
    ImX, ImY : shortint;
    Way, T : byte;
    Clip : boolean;
  end;
  Tmap = record
   iTile :array[1..17, 1..49] of TiTile;
  end;
 // :
  TcTile = record
    X, Y : integer;
  end;

const
  Kl_SX = 64;
  Kl_SY = 32;

var
  cTile : array[1..17, 1..49] of TcTile;
  rTile : array[1..17, 1..49] of TMRect;
  Map : Tmap;
  TMX, TMY : integer;

Procedure LoadMap(FN : string);
procedure Make_cTile;
procedure Draw_Tile;

implementation

uses
  Game_A, MainProc;

procedure Make_cTile;
var
  X, Y : byte;
begin
  for X:=1 to 17 do
  for Y:=1 to 24 do
    begin
      cTile[X, Y*2].X:=(X-1)*Kl_SX;
      cTile[X, Y*2].Y:=(Y-1)*Kl_SY;
    end;

  for X:=1 to 17 do
  for Y:=1 to 24+1 do
    begin
      cTile[X, (Y*2)-1].X:=(X-1)*Kl_SX - Kl_SX div 2;
      cTile[X, (Y*2)-1].Y:=(Y-1)*Kl_SY - Kl_SY div 2;
    end;

  for Y:=1 to 49 do
  for X:=1 to 17 do
    begin
      map.iTile[X, Y].ImX:=0;
      map.iTile[X, Y].ImY:=0;
      map.iTile[X, Y].Way:=0;
      map.iTile[X, Y].T:=0;
      map.iTile[X, Y].Clip:=false;
      pTile[X, Y].E:=false;

      RTile[X, Y].X:= cTile[X, Y].X + PAP_map.Kl_SX div 4 +3 ;
      RTile[X, Y].Y:= cTile[X, Y].Y + PAP_map.Kl_SY div 4 +3 ;
      RTile[X, Y].W:= PAP_map.Kl_SX div 2 -6;
      RTile[X, Y].H:= PAP_map.Kl_SY div 2 -6;
    end;
  setLength(Gun1Cord, 0);
  setLength(Gun2Cord, 0);
end;


procedure Draw_Tile;
function CA( A : single) : byte;
var
  r : integer;
begin
  r:=round(A);
  if (r>=0) and (r<=7) then
  result:=r
  else
  result:=0;
end;

var
  iX, iY : byte;
begin
  for iY:=1 to 49 do
  for iX:=1 to 17 do
    begin
      if Map.iTile[iX, iY].ImX>0 then
      Omega.ASprite_Draw(TI[Map.iTile[iX, iY].ImY],
                         cTile[iX, iY].X, cTile[iX, iY].Y, Kl_SX, Kl_SX*2,
                         Map.iTile[iX, iY].ImX);
    end;
  for iY:=1 to 49 do
  for iX:=1 to 17 do
    begin
      case Map.iTile[iX, iY].T of
        1: Omega.ASprite_Draw(Tgun,
                              cTile[iX, iY].X-32, cTile[iX, iY].Y-64, 128,  128, animatTile[iX, iY]);
        2: Omega.ASprite_Draw(Tgun,
                              cTile[iX, iY].X-32, cTile[iX, iY].Y-64, 128,  128, animatTile[iX, iY]);
        3: Omega.ASprite_Draw(Thome,
                              cTile[iX, iY].X-64, cTile[iX, iY].Y-128, 192, 192, animatTile[iX, iY] div 20);
        4: Omega.ASprite_Draw(Taltar,
                              cTile[iX, iY].X, cTile[iX, iY].Y-96, 64, 128, animatTile[iX, iY] div 20);
      end;
      if pTile[iX, iY].E then
      with HomeCord[pTile[iX, iY].H].Paps[pTile[iX, iY].Z] do
      begin
        Omega.SSprite_Draw(TShad, X, Y, Kl_SX, Kl_SY);
        
        if pTile[iX, iY].Z=0 then
        Omega.ASprite_Draw(TiShaman[CA(A)], X, Y-98, 64, 128, A2)
        else
        begin
          Omega.ASprite_Draw(TiPap[CA(A)], X, Y-98, 64, 128, A2);

          FX_SetColorMix(MainProc.SetExplColor(C));
          Omega.ASprite_Draw(TiCol[CA(A)], X, Y-98, 64, 128, A2, 255, 0,
          FX_DEFAULT or FX_COLORMIX);

        end;
      end;
        if iY>2 then
        if Map.iTile[iX, iY-2].T=3 then
        Omega.ASprite_Draw(Thome2, cTile[iX, iY-2].X-64, cTile[iX, iY-2].Y-128, 192, 192, animatTile[iX, iY-2] div 20);
      
    end;
end;

Procedure LoadMap(FN : string);
var
  F : file of Tmap;
  iX, iY, L : integer;
begin
  Make_cTile;
  assignfile(F, FN);
  reset(F);
  read(F, map);
  closefile(F);

  for iX:=1 to 17 do
  for iY:=1 to 49 do
    case Map.iTile[iX, iY].T of
      1 : begin
            L:=length(Gun1Cord);
            setLength(Gun1Cord, L+1);
            Gun1Cord[L].X:=iX;
            Gun1Cord[L].Y:=iY;
          end;
      2 : begin
            L:=length(Gun2Cord);
            setLength(Gun2Cord, L+1);
            Gun2Cord[L].X:=iX;
            Gun2Cord[L].Y:=iY;
          end;
      3 : begin
            L:=length(HomeCord);
            setLength(HomeCord, L+1);
            HomeCord[L].X:=iX;
            HomeCord[L].Y:=iY;
            CreatePaps(L);
          end;
      4 : begin
            L:=length(AltCord);
            setLength(AltCord, L+1);
            AltCord[L].X:=iX;
            AltCord[L].Y:=iY;
          end;
    end;
   
end;

end.
