{$MODE DELPHI}
program My_New_Game;
uses zglHeader;

const
   HeroWidth=128;
   VectorOfVelocity=6;
   VOVball=16;
   MainTimerTik=25;
   eps=0.00001;
   vr=16;
   br=12;
   quality=370;
   damageWithBall=10;
   HPBotType1=100;
   VectorOfMoveBot=2;
   Botw=64;
   herohp=1000;
type TPoint=record
  x,y:LongInt;
  mult:single;
end;

type TVagoncheg=record
  active:boolean;
  time:single;
  colors:array of LongInt;
  x,y,angle,incx,incy:single;
  point1,point2,way,color,left:LongInt;
end;
{
type TParovozeg=record
  V:array of TVagoncheg;  
  oldx,oldy:
  x,y:single;
end;}

type Thero=record
  sleep:int64;
  x,y:single;
  p:zglPTexture;
  timeToFire,color,hp:LongInt;
  ll,lr,lu,ld:boolean;
  active:boolean;
end;

type TBall=record
  x,y,incx,incy:single;
  angle,color:longInt;
  active:boolean;
end;

type TWay=record
  n:LongInt;
  mult:single;
  a:array of TPoint;
end;

type TNPC=record
active:boolean;
a:zglTRect;
hp,angle,incx,incy:single;
color,damage:LongInt;
t:LongInt;
end;

type TK=zglTcircle;

var scene:string;
    Hero:Thero;
    countVagoncheg,n,CountParovozeg:LongInt;
    way:array of TWay;
    level:LongInt;
    balls:array[1..25] of TBall;
    V:array of TVagoncheg;
    colors:array[1..50] of DWORD;
    bots:array[1..10] of TNPC;
    countColorsOnThisLevel:LongInt;
    globaltime:int64;
    mult:single;
    countWalls,countK:LongInt;
    k:array of TK;
    ColorWalls:DWORD;
    walls:array of zglTLine;
    ccolors:LongInt;
    count1,count2:LongInt;
    
procedure CreateBot(x,y,t:single);
var i:LongInt;
begin
  for i:=1 to 10 do
    if bots[i].active=false then
    begin
      bots[i].active:=true;
      bots[i].a.x:=x;
      bots[i].a.y:=y;
      bots[i].t:=trunc(t);
      bots[i].a.w:=botw;
      bots[i].hp:=HpBotType1;
      bots[i].a.h:=botw;
      bots[i].damage:=50;
      bots[i].color:=random(ccolors)+1; 
      exit;
      end;
end;

procedure SaveAndHalt;
begin
  close(output);
  halt(0);
end;
 
procedure CollisionAtStartPoint(i:LongInt);
var a1,a2:zglTCircle;j,q:LongInt;
begin
  a1.cX:=way[v[i].way].a[v[i].point1].x;
  a1.cY:=way[v[i].way].a[v[i].point1].y;
  a1.Radius:=vr+5;
  a2.cX:=v[i].x;
  a2.cY:=v[i].y;
  a2.Radius:=vr;
  if not col2d_Circle(a1,a2) then
    begin
       inc(countVagoncheg);
       j:=countVagoncheg;
       v[j].x:=way[v[i].way].a[v[i].point1].x;
       v[j].y:=way[v[i].way].a[v[i].point1].y;
       v[j].active:=true;
       v[j].point1:=v[i].point1;
       v[j].point2:=v[i].point2;
       v[j].color:=v[i].colors[1];
       SetLength(v[j].colors,v[i].left);
       for q:=1 to v[i].left-1 do
         v[j].colors[q]:=v[i].colors[q+1];
       v[j].way:=v[i].way;
       v[j].incx:=v[i].incx;
       v[j].incy:=v[i].incy;
       if v[j].color=0 then
         v[j].color:=random(ccolors)+1;
       v[j].left:=v[i].left-1;
       v[i].left:=0;
    end;
end;       
    
function OtherAngle(I:LongINt):boolean;
begin
  if M_Distance(v[i].x,v[i].y,
               way[v[i].way].a[v[i].point2].x,way[v[i].way].a[v[i].point2].y)>
   M_Distance(v[i].x-v[i].incx,v[i].y-v[i].incy,
               way[v[i].way].a[v[i].point2].x,way[v[i].way].a[v[i].point2].y) then OtherAngle:=true
               else OtherAngle:=false;
                               
end;

procedure RandColors;
var d:DWORD;I,j:LongInt;
begin
colors[1]:=$FFFF00;
colors[3]:=$FF0000;
colors[4]:=$FF3399;
colors[5]:=$0000FF;
colors[6]:=$00FF00;
colors[2]:=$009966;
				
  for i:=1 to 6 do
    begin
      j:=random(6)+1;
      d:=colors[i];colors[i]:=colors[j];colors[j]:=d;
    end;
end;

function WriteColor(number:LongInt):Dword;
begin
  WriteColor:=colors[number];
end;
    
procedure AngleToVelocity(i:LongInt;angle:single);
begin
  v[i].angle:=angle;
  v[i].incy:=vectorofvelocity*cos(angle);
  v[i].incx:=vectorofvelocity*sin(angle);
end;

function AngleX(angle,mult:Single):single;
begin
  AngleX:=mult*sin(angle);
end;

function AngleY(angle,mult:Single):single;
begin
  AngleY:=mult*cos(angle);
end;

procedure PaintBot(i:LongInt);
var x,y,r1,r2:single;
begin
  x:=bots[i].a.x+bots[i].a.w/2;
  y:=bots[i].a.y+bots[i].a.w/2;
  r1:=bots[i].a.w/2;
  r2:=bots[i].a.w/4;
  pr2d_circle(x,y,r2,$0000ff,255,quality,PR2D_SMOOTH);
  for i:=1 to 20 do
    pr2d_Line(x+AngleX(i*18+globaltime mod 18,r2),y+AngleY(i*18+globaltime mod 18,r2),x+AngleX(i*18+globaltime mod 18,r1),y+AngleY(i*18+globaltime mod 18,r1),$0000ff);

end;

procedure PaintK(I:Longint);
var x,y,r:single;
begin
  x:=k[i].cX;
  y:=k[i].cY; 
  r:=k[i].radius;
  for i:=1 to 20 do
    pr2d_Line(x,y,x+AngleX(i*18+globaltime mod 18,r),y+AngleY(i*18+globaltime mod 18,r),$00ff00);
end;

procedure LoadLevel(level:LongInt);
var i,j,q,w,p,c,color,z,time,vk:longInt;sing:single;
begin
  if level=12 then begin writeln('Вы прошли всю игру!) Бгг, я не ожидал от вас такого.');
  writeln(' Или вы просто смотрите в код, и читаете эту надпись?');
  writeln(' Спрашивается, зафиг вам эта бредовая надпись, сделанная в час ночи понедельника?');
  writeln(' А если вы прошли игру, то я буду очень рад, скажите мне об этом и подскажите, чего не хватает в моих играх.');
   writeln('Спасибо вам большое =)'); SaveAndHalt;end;
  assign(input,'levels/level'+U_inttostr(level)+'.MTF');
  reset(input);
    read(hero.x,hero.y,mult);
    hero.x:=hero.x+herowidth div 2;
    hero.y:=hero.y+herowidth div 2;
    hero.hp:=herohp;
    read(n);
    SetLength(way,n+1);
    for i:=1 to n do
      begin
        read(q);
        SetLength(way[i].a,q+1);
        way[i].n:=q;
        for j:=1 to q do
          read(way[i].a[j].x,way[i].a[j].y,way[i].a[j].mult);
        end;
        
       read(CountWalls);
       SetLength(walls,countWalls+1);
       for i:=1 to countWalls do 
         read(walls[i].x1,walls[i].y1,walls[i].x0,walls[i].y0);
       
       read(CountK);
       SetLength(K,CountK+1);
       for i:=1 to countK do
       begin
         read(k[i].Cx,k[i].Cy);
         k[i].radius:=16;
       end;
       read(countColorsOnTHisLevel,countParovozeg,countVagoncheg);
       SetLength(v,countVagoncheg+1);
       countVagoncheg:=countParovozeg;
       ccolors:=countColorsOnThisLevel;
       q:=0;
      for i:=1 to countParovozeg do
  begin
    inc(q);
    read(time,w,p,c);
    read(v[q].color);
    SetLength(v[q].colors,c);
    for j:=1 to c-1 do
      read(v[q].colors[j]);
    v[q].time:=time;
    v[q].x:=way[w].a[p].x;
    v[q].y:=way[w].a[p].y;
    v[q].way:=w;
    v[q].active:=false;
    if v[q].color=0 then
      v[q].color:=random(ccolors)+1;
    v[q].point1:=p;
    v[q].left:=c-1;
    v[q].point2:=p+1;
    if v[q].point2>way[w].n then v[i].point2:=1;
    AngleToVelocity(i,M_Angle(way[v[q].way].a[v[q].point1].x,way[v[q].way].a[v[q].point1].y,
                              way[v[q].way].a[v[q].point2].x,way[v[q].way].a[v[q].point2].y));
  end;  
  close(input);
  hero.color:=random(ccolors)+1;
end;

procedure EndLevel;
var i:Longint;
begin
  for i:=1 to countVagoncheg do
    if v[i].active=true then exit;
      
  writeln('Поздравляем! Вы прошли ',level,' уровень.'); 
  writeln('Вы потратили на это ',globaltime div 1000,' ','секунд');
  writeln('При этом, вы выстрелили ',count1,' раз, и попали ',count2,' раз,');
  writeln('Ваша точность ',trunc(count2/count1*100),' процентов');   
  inc(level);
  scene:='game';
  fillchar(balls,sizeof(balls),0);
  fillchar(bots,sizeof(bots),0);
  fillchar(k,sizeof(k),0);
  globaltime:=0;
  fillchar(walls,sizeof(walls),0);
  fillchar(v,sizeof(v),0);
  LoadLevel(level);
  randcolors;
  ColorWalls:=$00ff00;
  hero.active:=true;
  hero.sleep:=0;
  count1:=0;
  count2:=0;
  hero.color:=random(ccolors)+1;
  RandColors;
end;

procedure Paint;
var i,j:LongInt;
begin
  
  if scene='game' then
  begin
    for i:=1 to n do
    begin
      for j:=1 to way[i].n-1 do
        pr2d_Line(way[i].a[j].x,way[i].a[j].y,way[i].a[j+1].x,way[i].a[j+1].y,$ff0000);
      pr2d_Line(way[i].a[1].x,way[i].a[1].y,way[i].a[way[i].n].x,way[i].a[way[i].n].y,$ff0000);
    end;
    
    for i:=1 to countWalls do 
       pr2d_Line(walls[i].x0,walls[i].y0,walls[i].x1,walls[i].y1,$00ff00);
    
    for i:=1 to countVagoncheg do
      if v[i].active=true then
        pr2d_circle(v[i].x,v[i].y,vr,writeColor(v[i].color),255,quality,PR2D_SMOOTH);
        
    for i:=1 to 10 do
      if bots[i].active=true then
        PaintBot(i);
         
    for i:=1 to countK do
      PaintK(i);
      
  if hero.active then
    Pr2d_circle(hero.x,hero.y,herowidth div 2,$00ff00,255,quality,PR2D_SMOOTH)
  else pr2d_circle(hero.x,hero.y,herowidth div 2,$0000ff,255,quality,PR2D_SMOOTH);
    if not key_down(k_space) then
    pr2d_circle(hero.x,hero.y,br,writeColor(hero.color),255,quality,PR2D_FILL);
    for i:=1 to 25 do
      if balls[i].active=true then
      begin
        pr2d_circle(balls[i].x,balls[i].y,br,writeColor(balls[i].color),255,quality,PR2D_FILL);
      end;
    pr2d_circle(mouse_x,mouse_y,4,$00ffff,255,quality,PR2D_FILL); 
  end;    
end;

procedure Collision(b,w,t:LongInt);
var z1,z2:zglTCircle;
begin 
  z1.cX:=balls[b].x;
  z1.cY:=balls[b].y;
  z1.radius:=br;
  
  if t=1 then
  begin
    if (balls[b].active=false)or(v[w].active=false) then exit;
  z2.cX:=v[w].x;
  z2.cY:=v[w].y;
  z2.radius:=vr;
  if col2d_Circle(z1,z2)=true then
     if  v[w].color=balls[b].color then 
       begin balls[b].active:=false;v[w].active:=false;inc(count2);EndLevel;end
       else begin balls[b].active:=false;
         if random(20)=13 then
         CreateBot(v[w].x-vr,v[w].y-vr,1);end;
  end
  else
  begin
    if (balls[b].active=false)or(bots[w].active=false) then exit;
    if col2d_RectVSCircle(bots[w].a,z1) then
    begin
      inc(count2);
      bots[w].hp:=bots[w].hp-damageWithBall;
      if bots[w].hp<=0 then bots[w].active:=false; 
      balls[b].active:=false;
    end;
  end;
end;



procedure Process;
var i,j,q:longInt;angle:single;
c,bl:zglTCircle;
begin  
  if key_down(K_space) then begin hero.color:=random(ccolors)+1;end; 
  hero.ll:=false;hero.lr:=false;hero.lu:=false;hero.ld:=false;
  inc(globaltime,mainTimerTik);
  globaltime:=globaltime mod maxlongINt;
  if scene='game' then
  begin
    if hero.active then begin
   	 if key_down(k_w) then begin hero.y:=hero.y-4*mult;hero.lu:=true;end;
   	 if key_down(k_s) then begin hero.y:=hero.y+4*mult;hero.ld:=true;end;
   	 if key_down(k_a) then begin hero.x:=hero.x-4*mult;hero.ll:=true;end;
   	 if key_down(k_d) then begin hero.x:=hero.x+4*mult;hero.lr:=true;end;
    end
      else begin dec(hero.sleep,mainTImerTIk);if hero.sleep<=0 then hero.active:=true;end;
    if hero.x>1024 then hero.x:=1023;
    if hero.y>768 then hero.y:=767;
    if hero.x<0 then hero.x:=1;
    if hero.y<0 then hero.y:=1;
    if key_up(K_escape) then begin writeln('Вы вышли из моей поделки на ',level,' уровне. :(');
    writeln('Вы ведь пройдёте это потом, правда?'); close(output); zgl_exit;end;
   
    c.cX:=hero.x;
    c.cY:=hero.y;
    c.radius:=herowidth div 3;
    for i:=1 to 10 do
      if bots[i].active=true then
      begin
        bots[i].angle:=M_angle(bots[i].a.x+botw/2,bots[i].a.y+botw/2,hero.x,hero.y);
        if col2d_RectVsCircle(bots[i].a,c) then begin 
                                           bots[i].active:=false;
                                           hero.active:=false;
                                           hero.sleep:=3000;
                                           end;
        bots[i].incy:=VectorOfMoveBot*cos(bots[i].angle);
        bots[i].incx:=VectorOfMoveBot*sin(bots[i].angle);
        bots[i].a.x:=bots[i].a.x+bots[i].incx*mult;
        bots[i].a.y:=bots[i].a.y+bots[i].incy*mult;
      end;
    
    if hero.timetoFire>0 then
      dec(hero.timeToFire,maintimertik*3);
    
      
    if (mouse_down(M_BLEFT))and(hero.active) then
      if hero.timeToFire<=0 then
          for i:=1 to 25 do
            if balls[i].active=false then
            begin
              balls[i].active:=true;
              balls[i].x:=hero.x;
              balls[i].y:=hero.y;
              angle:=M_Angle(balls[i].x,balls[i].y,mouse_x,mouse_y);
              balls[i].incy:=vovball*cos(angle);
              balls[i].incx:=vovball*sin(angle);
              inc(count1);
              balls[i].angle:=round(angle);
              hero.timeToFire:=1000;
              balls[i].color:=hero.color;
              break;
            end;
                 
      for q:=1 to trunc(mult) do
      for i:=1 to 25 do
        if balls[i].active=true then
          begin
            balls[i].x:=balls[i].x+balls[i].incx*mult/trunc(mult);
            balls[i].y:=balls[i].y+balls[i].incy*mult/trunc(mult);
            if (balls[i].x>1024+16)or(balls[i].x<-16)or(balls[i].y>768+16)or(balls[i].y<-16) then balls[i].active:=false;
            for j:=1 to countVagoncheg do
              Collision(i,j,1);
            for j:=1 to 10 do
              if bots[j].active=true then
                  Collision(i,j,2);
          end;
   
    c.radius:=herowidth div 2;
    for i:=1 to countK do
      if col2d_Circle(c,k[i]) then begin
        if hero.lu=true then begin hero.y:=hero.y+4*mult;end;
        if hero.ld=true then begin hero.y:=hero.y-4*mult;end;
        if hero.ll=true then begin hero.x:=hero.x+4*mult;end;
        if hero.lr=true then begin hero.x:=hero.x-4*mult;end;
        hero.active:=false;
        hero.sleep:=1500;
      end;
      if countWalls>0 then
    for i:=1 to countWalls do
    begin
        if col2d_LineVSCircle(walls[i],c) then begin
          if hero.lu=true then begin hero.y:=hero.y+4*mult;end;
          if hero.ld=true then begin hero.y:=hero.y-4*mult;end;
          if hero.ll=true then begin hero.x:=hero.x+4*mult;end;
          if hero.lr=true then begin hero.x:=hero.x-4*mult;end;
        end;
        
       
        if col2d_LineVSCircle(walls[i],k[i]) then begin
        if hero.lu=true then begin hero.y:=hero.y+4*mult;end;
        if hero.ld=true then begin hero.y:=hero.y-4*mult;end;
        if hero.ll=true then begin hero.x:=hero.x+4*mult;end;
        if hero.lr=true then begin hero.x:=hero.x-4*mult;end;
        end;
        for j:=1 to 25 do
          if balls[j].active=true then
          begin
            bl.cX:=balls[j].x;bl.cY:=balls[j].y;bl.radius:=br;
            if col2d_LineVSCircle(walls[i],bl) then balls[j].active:=false;
          end;
    end;
    
    for i:=1 to countVagoncheg do
    begin
      if (v[i].active=false)and(globaltime>v[i].time)and(abs(v[i].time-globaltime)<maintimerTik*2) then v[i].active:=true;
      if v[i].active=true then
        begin
           if v[i].left>0 then CollisionAtStartPoint(i);
          v[i].x:=v[i].x+v[i].incx*mult*way[v[i].way].a[v[i].point2].mult;
          v[i].y:=v[i].y+v[i].incy*mult*way[v[i].way].a[v[i].point2].mult;
          if OtherAngle(i) then begin inc(v[i].point1);inc(v[i].point2);
                                          if v[i].point1>way[v[i].way].n then v[i].point1:=v[i].point1-way[v[i].way].n;
                                          if v[i].point2>way[v[i].way].n then v[i].point2:=v[i].point2-way[v[i].way].n;
                                               v[i].x:=way[v[i].way].a[v[i].point1].x;
                                               v[i].y:=way[v[i].way].a[v[i].point1].y;
                     AngleToVelocity(i,M_Angle(way[v[i].way].a[v[i].point1].x,way[v[i].way].a[v[i].point1].y,
                                               way[v[i].way].a[v[i].point2].x,way[v[i].way].a[v[i].point2].y));
        end; 
        end;
      end;                                
   end;
   Key_ClearState;
end;

procedure Init;
begin
  randomize;
  level:=1;
  scene:='game';
  fillchar(balls,sizeof(balls),0);
  fillchar(bots,sizeof(bots),0);
  fillchar(k,sizeof(k),0);
  fillchar(walls,sizeof(walls),0);
  fillchar(v,sizeof(v),0);
  LoadLevel(level);
  randcolors;
  ColorWalls:=$00ff00;
  hero.active:=true;
  hero.sleep:=0;
  hero.color:=random(ccolors)+1;
  RandColors;
end;

begin
  assign(output,'your_game.txt');
  rewrite(output);
  zglLoad(Libzengl);
  timer_Add(@Process,mainTimerTik);
  
  
  zgl_reg(SYS_DRAW,@Paint);
  zgl_reg(SYS_LOAD,@Init);
  
  scr_SetOptions(1024,768,32,0,false,false);
  
  zgl_init;

end.
